/*
 * WinExec-geometry Version 1.00
 * Copyright (C) 2002  hdk (Hideki EIRAKU)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -- 
 * Hideki EIRAKU
 * hdk@SoftHome.net
 */
#include <windows.h>
#include <stdio.h>

WNDPROC origwndproc;

LRESULT CALLBACK
wndproc (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
  POINT pt;
  RECT rc;
  char buf[100];
  HWND a;

  switch (msg)
    {
    case WM_DESTROY:
      PostQuitMessage (0);
      break;
    case WM_TIMER:
      if (GetCursorPos (&pt) && (a = WindowFromPoint (pt)))
	{
	  HWND b;
	  while ((GetWindowLong (a, GWL_STYLE) & WS_CHILD) &&
		 (b = GetParent (a)))
	    a = b;
	  if (a && GetWindowRect (a, &rc))
	    {
	      wsprintf (buf, "%ldx%ld+%ld+%ld", rc.right - rc.left,
			rc.bottom - rc.top, rc.left, rc.top);
	      SetWindowText (hwnd, buf);
	      SendMessage (hwnd, EM_SETSEL, 0, -1);
	    }
	}
      return 0;
    }
  return CallWindowProc (origwndproc, hwnd, msg, wparam, lparam);
}

static char *
skipspace (char *p)
{
  while (*p == ' ' || *p == '\t')
    p++;
  return p;
}

int STDCALL
WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR p, int nShow)
{
  STARTUPINFO si;
  PROCESS_INFORMATION pi;
  DWORD i, j;
  int k;

  p = skipspace (p);
  if (!*p)
    {
      HWND a;
      MSG msg;

      a = CreateWindow ("EDIT", "", WS_OVERLAPPEDWINDOW | ES_READONLY,
			CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
			CW_USEDEFAULT, 0, 0, hInst, 0);
      origwndproc = (WNDPROC)SetWindowLong (a, GWL_WNDPROC, (long)wndproc);
      SetTimer (a, 1, 100, 0);
      ShowWindow (a, SW_SHOWDEFAULT);
      while (GetMessage (&msg, 0, 0, 0))
	{
	  TranslateMessage (&msg);
	  DispatchMessage (&msg);
        }
      return 0;
    }
  memset (&si, 0, sizeof (si));
  si.cb = sizeof (si);
  if (sscanf (p, "%lux%lu%n", &i, &j, &k) >= 2)
    {
      si.dwFlags |= STARTF_USESIZE;
      si.dwXSize = i;
      si.dwYSize = j;
      p += k;
    }
  if (sscanf (p, "+%lu+%lu%n", &i, &j, &k) >= 2)
    {
      si.dwFlags |= STARTF_USEPOSITION;
      si.dwX = i;
      si.dwY = j;
      p += k;
    }
  p = skipspace (p);
  return CreateProcess (0, p, 0, 0, 0, 0, 0, 0, &si, &pi);
}
